Index: doc/theses/mubeen_zulfiqar_MMath/AllocDS1.fig
===================================================================
--- doc/theses/mubeen_zulfiqar_MMath/AllocDS1.fig	(revision dbfae7bce53b3200450caaf0d2c54c5e9d1ac211)
+++ doc/theses/mubeen_zulfiqar_MMath/AllocDS1.fig	(revision 78ea291f554d49a9ea3b3d85aeab620c92fa7089)
@@ -8,136 +8,155 @@
 -2
 1200 2
-6 4950 1275 5250 1425
-1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5025 1350 20 20 5025 1350 5045 1350
-1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5100 1350 20 20 5100 1350 5120 1350
-1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5175 1350 20 20 5175 1350 5195 1350
+6 4200 1575 4500 1725
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 4275 1650 20 20 4275 1650 4295 1650
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 4350 1650 20 20 4350 1650 4370 1650
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 4425 1650 20 20 4425 1650 4445 1650
 -6
-6 5700 1950 6000 2100
-1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5775 2025 20 20 5775 2025 5795 2025
-1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5850 2025 20 20 5850 2025 5870 2025
-1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5925 2025 20 20 5925 2025 5945 2025
--6
-6 3600 2100 3900 2475
+6 2850 2475 3150 2850
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 3675 2100 3675 2325
+	 2925 2475 2925 2700
 2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 3600 2325 3900 2325 3900 2475 3600 2475 3600 2325
+	 2850 2700 3150 2700 3150 2850 2850 2850 2850 2700
 -6
-6 5100 2100 5400 2475
+6 4350 2475 4650 2850
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 5175 2100 5175 2325
+	 4425 2475 4425 2700
 2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 5100 2325 5400 2325 5400 2475 5100 2475 5100 2325
+	 4350 2700 4650 2700 4650 2850 4350 2850 4350 2700
 -6
-6 4350 2100 4575 2775
+6 3600 2475 3825 3150
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 4425 2100 4425 2325
+	 3675 2475 3675 2700
 2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 4350 2325 4575 2325 4575 2475 4350 2475 4350 2325
+	 3600 2700 3825 2700 3825 2850 3600 2850 3600 2700
 2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 4350 2625 4575 2625 4575 2775 4350 2775 4350 2625
+	 3600 3000 3825 3000 3825 3150 3600 3150 3600 3000
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 4425 2400 4425 2625
+	 3675 2775 3675 3000
 -6
-6 5700 3225 6000 3375
-1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5775 3300 20 20 5775 3300 5795 3300
-1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5850 3300 20 20 5850 3300 5870 3300
-1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5925 3300 20 20 5925 3300 5945 3300
+6 4875 3600 5175 3750
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 4950 3675 20 20 4950 3675 4970 3675
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5025 3675 20 20 5025 3675 5045 3675
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5100 3675 20 20 5100 3675 5120 3675
+-6
+6 4875 2325 5175 2475
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 4950 2400 20 20 4950 2400 4970 2400
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5025 2400 20 20 5025 2400 5045 2400
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5100 2400 20 20 5100 2400 5120 2400
+-6
+6 5625 2325 5925 2475
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5700 2400 20 20 5700 2400 5720 2400
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5775 2400 20 20 5775 2400 5795 2400
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5850 2400 20 20 5850 2400 5870 2400
+-6
+6 5625 3600 5925 3750
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5700 3675 20 20 5700 3675 5720 3675
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5775 3675 20 20 5775 3675 5795 3675
+1 3 0 1 0 0 50 -1 20 0.000 1 0.0000 5850 3675 20 20 5850 3675 5870 3675
 -6
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 2700 1950 3900 1950
+	 2400 2100 2400 2550
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 3000 1800 3000 2175
+	 2550 2100 2550 2550
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 3150 1800 3150 2175
+	 2700 2100 2700 2550
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 3300 1800 3300 2175
+	 2850 2100 2850 2550
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 3450 1800 3450 2175
+	 3000 2100 3000 2550
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 3600 1800 3600 2175
+	 3600 2100 3600 2550
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 3750 1800 3750 2175
+	 3900 2100 3900 2550
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 4200 1950 5400 1950
+	 4050 2100 4050 2550
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 4350 1800 4350 2175
+	 4200 2100 4200 2550
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 4500 1800 4500 2175
+	 4350 2100 4350 2550
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 4650 1800 4650 2175
+	 4500 2100 4500 2550
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 4800 1800 4800 2175
+	 3300 1500 3300 1800
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 4950 1800 4950 2175
+	 3600 1500 3600 1800
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 5100 1800 5100 2175
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 5250 1800 5250 2175
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 4050 1200 4050 1500
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 4350 1200 4350 1500
-2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 4650 1200 4650 1500
+	 3900 1500 3900 1800
 2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 3750 1200 5550 1200 5550 1500 3750 1500 3750 1200
+	 3000 1500 4800 1500 4800 1800 3000 1800 3000 1500
 2 1 1 1 0 7 50 -1 -1 4.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 3975 1350 3375 1800
+	 3225 1650 2625 2100
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 3900 1350 3300 1800
+	 3150 1650 2550 2100
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 4200 1350 4800 1800
+	 3450 1650 4050 2100
 2 1 1 1 0 7 50 -1 -1 4.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 4125 1350 4725 1800
+	 3375 1650 3975 2100
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
-	 2850 1800 2850 2175
+	 2100 2100 2100 2550
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 1950 2250 3150 2250
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 3450 2250 4650 2250
 2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 2700 1800 3900 1800 3900 2175 2700 2175 2700 1800
+	 1950 2100 3150 2100 3150 2550 1950 2550 1950 2100
 2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 4200 1800 5400 1800 5400 2175 4200 2175 4200 1800
+	 3450 2100 4650 2100 4650 2550 3450 2550 3450 2100
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 2250 2100 2250 2550
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 3750 2100 3750 2550
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 2775 2100 2775 2325
+	 2025 2475 2025 2700
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
 	1 1 1.00 45.00 90.00
-	 2775 2400 2775 2625
+	 2025 2775 2025 3000
 2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 2700 2625 2850 2625 2850 2775 2700 2775 2700 2625
+	 1950 3000 2100 3000 2100 3150 1950 3150 1950 3000
 2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 2700 2325 2850 2325 2850 2475 2700 2475 2700 2325
+	 1950 2700 2100 2700 2100 2850 1950 2850 1950 2700
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 3
 	1 1 1.00 45.00 90.00
-	 2700 3375 3450 3375 3450 3150
+	 1950 3750 2700 3750 2700 3525
 2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 2700 3150 3900 3150 3900 3525 2700 3525 2700 3150
+	 1950 3525 3150 3525 3150 3900 1950 3900 1950 3525
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 3
 	1 1 1.00 45.00 90.00
-	 4200 3375 4950 3375 4950 3150
+	 3450 3750 4200 3750 4200 3525
 2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 4200 3150 5400 3150 5400 3525 4200 3525 4200 3150
+	 3450 3525 4650 3525 4650 3900 3450 3900 3450 3525
 2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 1 0 3
 	1 1 1.00 45.00 90.00
-	 3900 4350 4950 4350 4950 3900
+	 3150 4650 4200 4650 4200 4275
 2 2 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 3900 3900 5400 3900 5400 4575 3900 4575 3900 3900
-4 2 0 50 -1 0 12 0.0000 2 135 975 2625 2175 free buckets\001
-4 2 0 50 -1 0 12 0.0000 2 135 435 2625 1950 locks\001
-4 1 0 50 -1 0 12 0.0000 2 135 1365 4650 1125 N thread buckets\001
-4 1 0 50 -1 0 12 0.0000 2 180 390 5175 1725 heap\001
-4 1 0 50 -1 0 12 0.0000 2 180 390 2925 1725 heap\001
-4 1 0 50 -1 0 12 0.0000 2 180 915 3300 3075 bump alloc\001
-4 0 0 50 -1 0 12 0.0000 2 135 360 4275 3325 lock\001
-4 1 0 50 -1 0 12 0.0000 2 180 915 4800 3075 bump alloc\001
-4 0 0 50 -1 0 12 0.0000 2 135 360 3975 4075 lock\001
-4 1 0 50 -1 0 12 0.0000 2 135 345 4725 3825 sbrk\001
-4 0 0 50 -1 0 12 0.0000 2 135 360 2775 3325 lock\001
-4 2 0 50 -1 0 12 0.0000 2 135 675 2625 2625 free lists\001
+	 3150 4275 4650 4275 4650 4875 3150 4875 3150 4275
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 1950 2400 3150 2400
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 3450 2400 4650 2400
+2 1 0 1 0 7 50 -1 -1 0.000 0 0 -1 0 0 2
+	 5400 2100 5400 3900
+4 2 0 50 -1 0 11 0.0000 2 120 300 1875 2250 lock\001
+4 1 0 50 -1 0 12 0.0000 2 135 1935 3900 1425 N kernel-thread buckets\001
+4 1 0 50 -1 0 12 0.0000 2 195 810 4425 2025 heap$_2$\001
+4 1 0 50 -1 0 12 0.0000 2 195 810 2175 2025 heap$_1$\001
+4 2 0 50 -1 0 11 0.0000 2 120 270 1875 2400 size\001
+4 2 0 50 -1 0 11 0.0000 2 120 270 1875 2550 free\001
+4 1 0 50 -1 0 12 0.0000 2 180 825 2550 3450 local pool\001
+4 0 0 50 -1 0 12 0.0000 2 135 360 3525 3700 lock\001
+4 0 0 50 -1 0 12 0.0000 2 135 360 3225 4450 lock\001
+4 2 0 50 -1 0 12 0.0000 2 135 600 1875 3000 free list\001
+4 1 0 50 -1 0 12 0.0000 2 180 825 4050 3450 local pool\001
+4 1 0 50 -1 0 12 0.0000 2 180 1455 3900 4200 global pool (sbrk)\001
+4 0 0 50 -1 0 12 0.0000 2 135 360 2025 3700 lock\001
+4 1 0 50 -1 0 12 0.0000 2 180 720 6450 3150 free pool\001
+4 1 0 50 -1 0 12 0.0000 2 180 390 6450 2925 heap\001